#define DEBUG 0

#define MAXSTR 500
#define MAXNAZWA 100
#define MAXLEN 9
#define QUIET 0
#define DEBUG 0
#define TRUE 1
#define FALSE 0

/* for pre-ANSI compilers... */
#ifndef EXIT_SUCCESS
	#define EXIT_SUCCESS 0
#endif

#ifndef EXIT_FAILURE
	#define EXIT_FAILURE (1)
#endif

#ifndef RAND_MAX
	#define RAND_MAX (2147483647)
#endif

#ifndef SEQUENCE
	#define SEQUENCE "M.pneumoniae.fasta"
#endif

/* default data directory */
#ifndef DDIR
	#define DDIR "/usr/lib/genpak"
#endif

char yesno[2][4]={ "no", "yes" } ;



/* 
 * This variable is set to true if all the warnings are supposed to be
 * printed to stdout at the end of the program.
 */

int debug=DEBUG, quiet=QUIET, html=FALSE ;
char *progname ;

typedef enum {UNKNOWN=0, DNA, RNA, PROTEIN, WRONG } sequence_type ;

extern char stypes[5][10] ;
extern char one2three[128][4] ;

typedef struct {
	char name[MAXNAZWA] ;
	char *sequ ;
	long leng ;
	sequence_type type ; } sekw ;

typedef struct {
  char tbl[4][4][4] ;
} codont ;

struct position_ss {
	long start ;
	long end ; 
	struct postion_ss* next ; 
} ;

typedef struct position_ss position_s ;


/*
 * we need a structure to store all the warnings issued by the program
 * in case we need to print them all one at the time, that is when
 * html==TRUE.
 */

struct warnings_s {
  char warn[200] ;
  struct warnings_s *next ;
};

struct warnings_s *allwarnings ;
struct warnings_s *currentwarning ;


extern void PrintAllWarnings(FILE* out) ;
extern void Programming_Error() ;
extern void InitializeOne2Three() ;
extern codont* LoadStandardTable() ;
extern sekw* Dna2Protein(sekw *inseq, 
		codont* intable, long start, int pedantic) ;
extern sekw* CopySeqFrag(sekw * s, long start, long end) ;
extern int FormatSeq(FILE* out, sekw* s, int width) ;
extern sekw* ReadSeqFrag(FILE *in, long start, long end, int numseq) ;
extern sekw* ReverseSequence(sekw* s) ;
extern sequence_type GetSeqType(sekw *s) ;
extern void Error(char *message, ...) ;
extern void Warn(char *message, ...) ;
extern char Complement(char c) ;
extern int Compare(char c1, char c2) ;
extern FILE* TryOpen(char *file, char* type) ;
extern int IsStartCodon(sekw *s, long p) ;
extern position_s *FindSeq(sekw *query, sekw *subject) ;
extern double VarianceE(double sum, double sumofsquares, int number) ;
extern sekw* ReadWholeSequence(FILE *in) ;
void Help() ;
